IncludeFile "Operno.pbi"



Global *ColorLibrary.OpernoObject



Procedure.i Std_Color_RGB()
  Protected Red.i, Green.i, Blue.i
  
  OpernoPopIValue(@Red)
  OpernoPopIValue(@Green)
  OpernoPopIValue(@Blue)
  
  ProcedureReturn OpernoPushIValue(Red | Green << 8 | Blue << 16)
EndProcedure
Procedure.i Std_Color_Red()
  Protected Color.i
  
  OpernoPopIValue(@Color)
  
  ProcedureReturn OpernoPushIValue(Color & $FF)
EndProcedure
Procedure.i Std_Color_Green()
  Protected Color.i
  
  OpernoPopIValue(@Color)
  
  ProcedureReturn OpernoPushIValue(Color >> 8 & $FF)
EndProcedure
Procedure.i Std_Color_Blue()
  Protected Color.i
  
  OpernoPopIValue(@Color)
  
  ProcedureReturn OpernoPushIValue(Color >> 16 & $FF)
EndProcedure
Procedure.i Std_Color_Display()
  Protected Color.i, Window.i, Event.i
  
  OpernoPopIValue(@Color)
  
  Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 200, 200, "Color", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
    StartDrawing(WindowOutput(Window))
      Box(0, 0, 200, 200, Color)
    StopDrawing()
  
  Repeat
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
  
  CloseWindow(Window)
EndProcedure



Procedure.i Std_Integer_Red()
  ProcedureReturn OpernoPushIValue(OpernoValueI(OpernoThis()) & $FF)
EndProcedure
Procedure.i Std_Integer_Green()
  ProcedureReturn OpernoPushIValue(OpernoValueI(OpernoThis()) >> 8 & $FF)
EndProcedure
Procedure.i Std_Integer_Blue()
  ProcedureReturn OpernoPushIValue(OpernoValueI(OpernoThis()) >> 16 & $FF)
EndProcedure



ProcedureDLL.i InitLibrary()
  ; Create color-library:
  *ColorLibrary = OpernoCreateGroup("color", *OpernoStandardLibrary)
  OpernoExtractObject(*ColorLibrary, ?Std_Color)
  ; Extend integer-class:
  OpernoExtractObject(*OpernoIntegerClass, ?Std_IntegerColor)
EndProcedure
ProcedureDLL.i ColorLibrary()
  ProcedureReturn *ColorLibrary
EndProcedure



DataSection
  Std_Color:
    Data.c #OpernoObject_Function : Data.s "rgb" ;{
      Data.i @Std_Color_RGB()
    ;}
    Data.c #OpernoObject_Function : Data.s "red" ;{
      Data.i @Std_Color_Red()
    ;}
    Data.c #OpernoObject_Function : Data.s "green" ;{
      Data.i @Std_Color_Green()
    ;}
    Data.c #OpernoObject_Function : Data.s "blue" ;{
      Data.i @Std_Color_Blue()
    ;}
    Data.c #OpernoObject_Function : Data.s "display" ;{
      Data.i @Std_Color_Display()
    Data.s "disp"
    ;}
    Data.c #Null
  
  Std_IntegerColor:
    Data.c #OpernoObject_Function : Data.s "red" ;{
      Data.i @Std_Integer_Red()
    ;}
    Data.c #OpernoObject_Function : Data.s "green" ;{
      Data.i @Std_Integer_Green()
    ;}
    Data.c #OpernoObject_Function : Data.s "blue" ;{
      Data.i @Std_Integer_Blue()
    ;}
    Data.c #Null
EndDataSection
; IDE Options = PureBasic 4.40 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 72
; FirstLine = 63
; Folding = -PA-
; EnableXP