IncludeFile "Operno.pbi"



Global *CursorLibrary.OpernoObject



Procedure.i Std_Cursor_X()
  Protected Position.POINT
  
  GetCursorPos_(@Position)
  ProcedureReturn OpernoPushIValue(Position\X)
EndProcedure
Procedure.i Std_Cursor_Y()
  Protected Position.POINT
  
  GetCursorPos_(@Position)
  ProcedureReturn OpernoPushIValue(Position\Y)
EndProcedure
Procedure.i Std_Cursor_Locate()
  Protected Position.POINT
  
  If OpernoPopIValue(@Position\X) And OpernoPopIValue(@Position\Y)
    SetCursorPos_(Position\X, Position\Y)
  EndIf
EndProcedure
Procedure.i Std_Cursor_Move()
  Protected Position.POINT, Move.POINT
  
  If OpernoPopIValue(@Move\X) And OpernoPopIValue(@Move\Y)
    GetCursorPos_(@Position)
    SetCursorPos_(Position\X + Move\X, Position\Y + Move\Y)
  EndIf
EndProcedure
Procedure.i Std_Cursor_LeftClick()
  mouse_event_(#MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
  mouse_event_(#MOUSEEVENTF_LEFTUP, 0, 0, 0, 0)
EndProcedure
Procedure.i Std_Cursor_RightClick()
  mouse_event_(#MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0)
  mouse_event_(#MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0)
EndProcedure
Procedure.i Std_Cursor_Scroll()
  Protected Ticks.i
  
  If OpernoPopIValue(@Ticks)
    mouse_event_(#MOUSEEVENTF_WHEEL, 0, 0, Ticks * 120, 0)
  Else
    _OpernoArgumentError(1)
  EndIf
EndProcedure



ProcedureDLL.i InitLibrary()
  *CursorLibrary = OpernoCreateGroup("cursor", *OpernoStandardLibrary)
  OpernoExtractObject(*CursorLibrary, ?Std_Cursor)
EndProcedure
ProcedureDLL.i CursorLibrary()
  ProcedureReturn *CursorLibrary
EndProcedure



DataSection
  Std_Cursor:
    Data.c #OpernoObject_Function : Data.s "x" ;{
      Data.i @Std_Cursor_X()
    ;}
    Data.c #OpernoObject_Function : Data.s "y" ;{
      Data.i @Std_Cursor_Y()
    ;}
    Data.c #OpernoObject_Function : Data.s "locate" ;{
      Data.i @Std_Cursor_Locate()
    ;}
    Data.c #OpernoObject_Function : Data.s "move" ;{
      Data.i @Std_Cursor_Move()
    ;}
    Data.c #OpernoObject_Function : Data.s "leftClick" ;{
      Data.i @Std_Cursor_LeftClick()
    ;}
    Data.c #OpernoObject_Function : Data.s "rightClick" ;{
      Data.i @Std_Cursor_RightClick()
    ;}
    Data.c #OpernoObject_Function : Data.s "scroll" ;{
      Data.i @Std_Cursor_Scroll()
    ;}
    Data.c #Null
EndDataSection

; IDE Options = PureBasic 4.40 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 78
; FirstLine = 49
; Folding = -6-
; EnableXP