IncludeFile "Operno.pbi"



Procedure.i Std_Math_Distance()
  Protected X1.f, Y1.f, X2.f, Y2.f
  Protected A.f, B.f
  
  If OpernoPopFValue(@X1) And OpernoPopFValue(@Y1) And OpernoPopFValue(@X2) And OpernoPopFValue(@Y2)
    A = Abs(X2 - X1)
    B = Abs(Y2 - Y1)
    ProcedureReturn OpernoPushFValue(Sqr(A*A + B*B))
  Else
    _OpernoArgumentError(4)
  EndIf
EndProcedure
Procedure.i Std_Math_SquareSum()
  Protected Result.i
  
  If OpernoPopIValue(@Result)
    While Number
      Result + Number % (10)
      Number / 10
    Wend
    ProcedureReturn OpernoPushIValue(Result)
  Else
    _OpernoArgumentError(1)
  EndIf
EndProcedure
Procedure.i Std_Math_IsPrime()
  Protected Number.i
  Protected Divisor.i, Maximum.i
  
  If OpernoPopIValue(@Number)
    Maximum = Sqr(Number)
    For Divisor = 2 To Maximum
      If Number % Divisor = 0
        ProcedureReturn OpernoPushBValue(#False)
      EndIf
    Next
    ProcedureReturn OpernoPushBValue(#True)
  Else
    _OpernoArgumentError(1)
  EndIf
EndProcedure
Procedure.i Std_Math_Gauss()
  Protected *Matrix.OpernoValue, Lines.i, Index.i
  Protected A, B
  Protected *ValueA.OpernoValue, *ValueB.OpernoValue, *LineA.OpernoValue, *LineB.OpernoValue
  Protected *Value.OpernoValue
  
  If OpernoPopValue(@*Matrix)
    If Not *Matrix\Class = *OpernoQueueClass
      _OpernoError("Matrix required.")
    EndIf
    
    Lines = OpernoItemCount(*Matrix)
    If OpernoItemCount(OpernoItemValue(OpernoFirstItem(*Matrix))) - 1 <> Lines
      _OpernoError("(n * n+1) matrix required.")
    EndIf
    
    A = OpernoFirstItem(*Matrix)
    While A
      B = OpernoNextItem(A)
      While B
        *LineA  = OpernoItemValue(A)
        *LineB  = OpernoItemValue(B)
        *ValueA = OpernoItemValue(OpernoItem(*LineA, Index))
        *ValueB = OpernoItemValue(OpernoItem(*LineB, Index))
        
        *Value = OpernoOperateValue(#OpernoOperator_Divide    , *LineA, *ValueA) ;X = A / A(index)
        *Value = OpernoOperateValue(#OpernoOperator_Multiply  , *Value, *ValueB) ;X = X * B(index)
                 OpernoOperateValue(#OpernoOperator_DoSubtract, *LineB, *Value)  ;B = B - X
        
        B = OpernoNextItem(B)
      Wend
      A = OpernoNextItem(A)
      Index + 1
    Wend
    
    ProcedureReturn *Matrix
  Else
    _OpernoArgumentError(1)
  EndIf
EndProcedure



ProcedureDLL.i InitLibrary()
  OpernoExtractObject(OpernoGet("math", *OpernoStandardLibrary), ?Std_MathExtension)
EndProcedure



DataSection
  Std_MathExtension:
    Data.c #OpernoObject_Function : Data.s "distance" ;{
      Data.i @Std_Math_Distance()
    Data.s "dis"
    ;}
    Data.c #OpernoObject_Function : Data.s "squareSum" ;{
      Data.i @Std_Math_SquareSum()
    ;}
    Data.c #OpernoObject_Function : Data.s "prime?" ;{
      Data.i @Std_Math_IsPrime()
    ;}
    Data.c #OpernoObject_Function : Data.s "gauss" ;{
      Data.i @Std_Math_Gauss()
    ;}
    Data.c #Null
EndDataSection
; IDE Options = PureBasic 4.41 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 95
; FirstLine = 73
; Folding = --
; EnableXP
; Executable = ..\mathEx.dll
; CompileSourceDirectory