;**************************************************************
;     Check memory
;
; Autor: Josef Sniatecki
; Creation date: 29.07.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Structure Address
  Real.i
  Number.i
EndStructure



Global AllocatedNumber.i = -1
Global NewList Address.Address()



Procedure.i MyAllocateMemory(Size)
  Protected *Memory
  *Memory = AllocateMemory(Size)
  
  If AllocatedNumber > -1
    AddElement(Address())
    Address()\Real = *Memory
    Address()\Number = AllocatedNumber
    
    AllocatedNumber + 1
    
    Debug "NEW " + LSet(Str(Address()\Number), 5) + " : " + Str(Address()\Real)
  EndIf
  ProcedureReturn *Memory
EndProcedure
Procedure.i MyFreeMemory(*Memory)
  FreeMemory(*Memory)
  
  If ListSize(Address())
    ForEach Address()
      If Address()\Real = *Memory
        Break
      EndIf
    Next
    
    Debug "DEL " + LSet(Str(Address()\Number), 5) + " : " + Str(Address()\Real)
    DeleteElement(Address())
  EndIf
EndProcedure



Macro AllocateMemory(Size)
  MyAllocateMemory(Size)
EndMacro
Macro FreeMemory(Memory)
  MyFreeMemory(Memory)
EndMacro
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableXP