;**************************************************************
;     Boolean (class)
;
; Autor: Josef Sniatecki
; Creation date: 12.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i Std_Boolean_Invert()
  ProcedureReturn PushBValue(#True - *Current\This\Integer\I)
EndProcedure
Procedure.i Std_Boolean_DoInvert()
  *Current\This\Integer\I = #True - *Current\This\Integer\I
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Boolean_Select()
  Protected *True.Value, *False.Value
  
  PopValueAddress(@*True)
  PopValueAddress(@*False)
  
  If *Current\This\Integer\I
    ProcedureReturn *True
  Else
    ProcedureReturn *False
  EndIf
EndProcedure
Procedure.i Std_Boolean__New()
  *Current\This\Integer = _New(Integer)
  *Current\This\Scope   | #Value_Binary
EndProcedure
Procedure.i Std_Boolean__Def()
  PopBValue(*Current\This\Integer)
EndProcedure
Procedure.i Std_Boolean__Del()
  FreeMemory(*Current\This\Integer)
EndProcedure
Procedure.i Std_Boolean__IsTrue()
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Boolean__Set()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *BooleanClass
      *Current\This\Integer\I = *Value\Integer\I
    Case *IntegerClass
      If *Value\Integer\I
        *Current\This\Integer\I = #True
      Else
        *Current\This\Integer\I = #False
      EndIf
    Case *StringClass
      If LCase(*Value\String\S) = "true"
        *Current\This\Integer\I = #True
      ElseIf LCase(*Value\String\S) = "false"
        *Current\This\Integer\I = #False
      EndIf
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Boolean__Mul()
  Protected *Value.Value, *Item.QueueItem
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *QueueClass
      If *Current\This\Integer\I
        *Item = *Value\Queue\First
        If *Item
          ProcedureReturn *Item\Value
        EndIf
      Else
        *Item = *Value\Queue\First
        If *Item\N
          ProcedureReturn *Item\N\Value
        Else
          _Error("A queue must have two items.")
        EndIf
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Boolean__Eq()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Integer\I = *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *StringClass
      If (*Current\This\Integer\I And LCase(*Value\String\S) = "true") Or (Not *Current\This\Integer\I And LCase(*Value\String\S) = "false")
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Boolean__Form()
  If *Current\This\Integer\I
    ProcedureReturn PushSValue("True")
  Else
    ProcedureReturn PushSValue("False")
  EndIf
EndProcedure

DataSection
  BooleanClass:
    Data.c #Object_Function : Data.s "invert" ;{
      Data.i @Std_Boolean_Invert()
    Data.s "inv"
    ;}
    Data.c #Object_Function : Data.s "invert!" ;{
      Data.i @Std_Boolean_DoInvert()
    Data.s "inv!"
    ;}
    Data.c #Object_Function : Data.s "select" ;{
      Data.i @Std_Boolean_Select()
    Data.s "sel"
    ;}
    Data.c #Object_Function : Data.s _CM(new) ;{
      Data.i @Std_Boolean__New()
    ;}
    Data.c #Object_Function : Data.s _CM(def) ;{
      Data.i @Std_Boolean__Def()
    ;}
    Data.c #Object_Function : Data.s _CM(del) ;{
      Data.i @Std_Boolean__Del()
    ;}
    Data.c #Object_Function : Data.s _CM(true?) ;{
      Data.i @Std_Boolean__IsTrue()
    ;}
    Data.c #Object_Function : Data.s _CM(set) ;{
      Data.i @Std_Boolean__Set()
    ;}
    Data.c #Object_Function : Data.s _CM(eq) ;{
      Data.i @Std_Boolean__Eq()
    ;}
    Data.c #Object_Function : Data.s _CM(mul) ;{
      Data.i @Std_Boolean__Mul()
    ;}
    Data.c #Object_Function : Data.s _CM(form) ;{
      Data.i @Std_Boolean__Form()
    ;}
    Data.c #False
EndDataSection

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 96
; FirstLine = 75
; Folding = ----
; EnableXP