;**************************************************************
;     Integer (class)
;
; Autor: Josef Sniatecki
; Creation date: 05.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i Std_Integer_Abs()
  ProcedureReturn PushIValue(Abs(*Current\This\Integer\I))
EndProcedure
Procedure.i Std_Integer_DoAbs()
  *Current\This\Integer\I = Abs(*Current\This\Integer\I)
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Integer_Char()
  ProcedureReturn PushSValue(Chr(*Current\This\Integer\I))
EndProcedure
Procedure.i Std_Integer_Times()
  Protected *ResultQueue.Queue, Index.i
  
  Index        = *Current\This\Integer\I
  *ResultQueue = CreateQueue(@FreeValue())
  
  While Index
    PrependQueueItem(*ResultQueue, CreateIValue(Index))
    Index - 1
  Wend
  
  ProcedureReturn PushQueueValue(*ResultQueue)
EndProcedure
Procedure.i Std_Integer__New()
  *Current\This\Integer = _New(Integer)
  *Current\This\Scope   | #Value_Binary
EndProcedure
Procedure.i Std_Integer__Def()
  PopIValue(*Current\This\Integer)
EndProcedure
Procedure.i Std_Integer__Del()
  _Free(*Current\This\Memory)
EndProcedure
Procedure.i Std_Integer__IsTrue()
  If *Current\This\Integer\I
    ProcedureReturn PushBValue(#True)
  Else
    ProcedureReturn PushBValue(#False)
  EndIf
EndProcedure
Procedure.i Std_Integer__Set()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Integer\I = *Value\Integer\I
      ProcedureReturn *Value
    Case *FloatClass
      *Current\This\Integer\I = *Value\Float\F
      ProcedureReturn *Value
    Case *QuadClass
      *Current\This\Integer\I = *Value\Quad\Q
      ProcedureReturn *Value
    Case *DoubleClass
      *Current\This\Integer\I = *Value\Double\D
      ProcedureReturn *Value
    Case *StringClass
      *Current\This\Integer\I = Val(*Value\String\S)
      ProcedureReturn *Value
  EndSelect
  ProcedureReturn #Null
EndProcedure
Procedure.i Std_Integer__Add()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      ProcedureReturn PushIValue(*Current\This\Integer\I + *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushFValue(*Current\This\Integer\I + *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushQValue(*Current\This\Integer\I + *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Integer\I + *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Integer__Sub()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      ProcedureReturn PushIValue(*Current\This\Integer\I - *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushFValue(*Current\This\Integer\I - *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushQValue(*Current\This\Integer\I - *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Integer\I - *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Integer__Neg()
  ProcedureReturn PushIValue(-*Current\This\Integer\I)
EndProcedure
Procedure.i Std_Integer__Mul()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      ProcedureReturn PushIValue(*Current\This\Integer\I * *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushFValue(*Current\This\Integer\I * *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushQValue(*Current\This\Integer\I * *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Integer\I * *Value\Double\D)
    Case *StringClass
      ProcedureReturn PushSValue(MStr(*Value\String\S, *Current\This\Integer\I))
    Case *BlockClass
      ProcedureReturn MultiplyBlock(*Value\Queue, *Current\This\Integer\I)
  EndSelect
EndProcedure
Procedure.i Std_Integer__Div()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass
      ProcedureReturn PushIValue(*Current\This\Integer\I / *Value\Integer\I)
    Case *FloatClass
      ProcedureReturn PushFValue(*Current\This\Integer\I / *Value\Float\F)
    Case *QuadClass
      ProcedureReturn PushQValue(*Current\This\Integer\I / *Value\Quad\Q)
    Case *DoubleClass
      ProcedureReturn PushDValue(*Current\This\Integer\I / *Value\Double\D)
  EndSelect
EndProcedure
Procedure.i Std_Integer__Pow()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass
      ProcedureReturn PushIValue(Pow(*Current\This\Integer\I, *Value\Integer\I))
    Case *FloatClass
      ProcedureReturn PushFValue(Pow(*Current\This\Integer\I, *Value\Float\F))
    Case *QuadClass
      ProcedureReturn PushQValue(Pow(*Current\This\Integer\I, *Value\Quad\Q))
    Case *DoubleClass
      ProcedureReturn PushDValue(Pow(*Current\This\Integer\I, *Value\Double\D))
  EndSelect
EndProcedure
Procedure.i Std_Integer__DoAdd()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Integer\I + *Value\Integer\I
    Case *FloatClass
      *Current\This\Integer\I + *Value\Float\F
    Case *QuadClass
      *Current\This\Integer\I + *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Integer\I + *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Integer__DoSub()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Integer\I - *Value\Integer\I
    Case *FloatClass
      *Current\This\Integer\I - *Value\Float\F
    Case *QuadClass
      *Current\This\Integer\I - *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Integer\I - *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Integer__DoMul()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Integer\I * *Value\Integer\I
    Case *FloatClass
      *Current\This\Integer\I * *Value\Float\F
    Case *QuadClass
      *Current\This\Integer\I * *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Integer\I * *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Integer__DoDiv()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      *Current\This\Integer\I / *Value\Integer\I
    Case *FloatClass
      *Current\This\Integer\I / *Value\Float\F
    Case *QuadClass
      *Current\This\Integer\I / *Value\Quad\Q
    Case *DoubleClass
      *Current\This\Integer\I / *Value\Double\D
  EndSelect
  ProcedureReturn *Value
EndProcedure
Procedure.i Std_Integer__Eq()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Integer\I = *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *FloatClass
      If *Current\This\Integer\I = *Value\Float\F
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *QuadClass
      If *Current\This\Integer\I = *Value\Quad\Q
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *DoubleClass
      If *Current\This\Integer\I = *Value\Double\D
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Integer__Le()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Integer\I < *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *FloatClass
      If *Current\This\Integer\I < *Value\Float\F
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *QuadClass
      If *Current\This\Integer\I < *Value\Quad\Q
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *DoubleClass
      If *Current\This\Integer\I < *Value\Double\D
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Integer__Gr()
  Protected *Value.Value
  
  PopValueAddress(@*Value)
  Select *Value\Class
    Case *IntegerClass, *BooleanClass
      If *Current\This\Integer\I > *Value\Integer\I
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *FloatClass
      If *Current\This\Integer\I > *Value\Float\F
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *QuadClass
      If *Current\This\Integer\I > *Value\Quad\Q
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
    Case *DoubleClass
      If *Current\This\Integer\I > *Value\Double\D
        ProcedureReturn PushBValue(#True)
      Else
        ProcedureReturn PushBValue(#False)
      EndIf
  EndSelect
EndProcedure
Procedure.i Std_Integer__Inc()
  *Current\This\Integer\I + 1
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Integer__Dec()
  *Current\This\Integer\I - 1
  ProcedureReturn *Current\This
EndProcedure
Procedure.i Std_Integer__Form()
  ProcedureReturn PushSValue(Str(*Current\This\Integer\I))
EndProcedure

DataSection
  IntegerClass:
    Data.c #Object_Function : Data.s "abs" ;{
      Data.i @Std_Integer_Abs()
    ;}
    Data.c #Object_Function : Data.s "abs!" ;{
      Data.i @Std_Integer_DoAbs()
    ;}
    Data.c #Object_Function : Data.s "char" ;{
      Data.i @Std_Integer_Char()
    ;}
    Data.c #Object_Function : Data.s "times" ;{
      Data.i @Std_Integer_Times()
    ;}
    Data.c #Object_Function : Data.s _CM(new) ;{
      Data.i @Std_Integer__New()
    ;}
    Data.c #Object_Function : Data.s _CM(def) ;{
      Data.i @Std_Integer__Def()
    ;}
    Data.c #Object_Function : Data.s _CM(del) ;{
      Data.i @Std_Integer__Del()
    ;}
    Data.c #Object_Function : Data.s _CM(true?) ;{
      Data.i @Std_Integer__IsTrue()
    ;}
    Data.c #Object_Function : Data.s _CM(set) ;{
      Data.i @Std_Integer__Set()
    ;}
    Data.c #Object_Function : Data.s _CM(add) ;{
      Data.i @Std_Integer__Add()
    ;}
    Data.c #Object_Function : Data.s _CM(sub) ;{
      Data.i @Std_Integer__Sub()
    ;}
    Data.c #Object_Function : Data.s _CM(neg) ;{
      Data.i @Std_Integer__Neg()
    Data.s "negative"
    ;}
    Data.c #Object_Function : Data.s _CM(mul) ;{
      Data.i @Std_Integer__Mul()
    ;}
    Data.c #Object_Function : Data.s _CM(div) ;{
      Data.i @Std_Integer__Div()
    ;}
    Data.c #Object_Function : Data.s _CM(pow) ;{
      Data.i @Std_Integer__Pow()
    ;}
    Data.c #Object_Function : Data.s _CM(add!) ;{
      Data.i @Std_Integer__DoAdd()
    ;}
    Data.c #Object_Function : Data.s _CM(sub!) ;{
      Data.i @Std_Integer__DoSub()
    ;}
    Data.c #Object_Function : Data.s _CM(mul!) ;{
      Data.i @Std_Integer__DoMul()
    ;}
    Data.c #Object_Function : Data.s _CM(div!) ;{
      Data.i @Std_Integer__DoDiv()
    ;}
    Data.c #Object_Function : Data.s _CM(eq) ;{
      Data.i @Std_Integer__Eq()
    ;}
    Data.c #Object_Function : Data.s _CM(le) ;{
      Data.i @Std_Integer__Le()
    ;}
    Data.c #Object_Function : Data.s _CM(gr) ;{
      Data.i @Std_Integer__Gr()
    ;}
    Data.c #Object_Function : Data.s _CM(inc) ;{
      Data.i @Std_Integer__Inc()
    ;}
    Data.c #Object_Function : Data.s _CM(dec) ;{
      Data.i @Std_Integer__Dec()
    ;}
    Data.c #Object_Function : Data.s _CM(form) ;{
      Data.i @Std_Integer__Form()
    ;}
    Data.c #False
EndDataSection

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 4
; Folding = ---------
; EnableXP