;**************************************************************
;     Reference (class)
;
; Autor: Josef Sniatecki
; Creation date: 08.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i PrepareReference(*Reference.Value, *Original.Value)
  While *Original\Original
    *Original = *Original\Original
  Wend
  ; Do not assing the Original value, if the memory is a reference:
  If Not *Original\Scope&#Value_Reference
    *Reference\Original = *Original
    If Not *Original\ReferenceQueue
      *Original\ReferenceQueue = CreateQueue(#Queue_SaveMemory)
    EndIf
    AppendQueueItem(*Original\ReferenceQueue, *Reference)
  EndIf
EndProcedure
Procedure.i UpdateReferences(*Original.Value)
  Protected *Item.QueueItem, *Reference.Value
  
  If *Original\ReferenceQueue
    *Item = *Original\ReferenceQueue\First
    While *Item
      *Reference          = *Item\Memory
      *Reference\Class    = *Original\Class
      *Reference\Memory   = *Original\Memory
      *Reference\Scope    = *Original\Scope|#Value_Reference
      *Reference\Variable = *Original\Variable
      _Move(*Item, N)
    Wend
  EndIf
EndProcedure
Procedure.i ResetReferences(*ReferenceQueue.Queue)
  Protected *Item.QueueItem, *Reference.Value
  
  *Item = *ReferenceQueue\First
  While *Item
    *Reference          = *Item\Memory
    *Reference\Class    = *ReferenceClass
    *Reference\Memory   = #Null
    *Reference\Scope    = #Value_Binary|#Value_Reference
    *Reference\Original = #Null
    *Reference\Variable = #Null
    _Move(*Item, N)
  Wend
  FreeQueue(*ReferenceQueue)
EndProcedure
Procedure.i FreeReference(*Reference.Value)
  Protected *Item.QueueItem
  
  *Item = *Reference\Original\ReferenceQueue\First
  While *Item
    If *Item\Value = *Reference
      FreeQueueItem(*Reference\Original\ReferenceQueue, *Item)
      Break
    EndIf
    _Move(*Item, N)
  Wend
EndProcedure



Procedure.i Std_Reference__New()
  *Current\This\Scope|#Value_Binary|#Value_Reference
EndProcedure
Procedure.i Std_Reference__DefAndSet()
  Protected *This.Value = *Current\This, *Value.Value
  
  If PopValueAddress(@*Value)
    PrepareReference(*This, *Value)
    *This\Class    = *Value\Class
    *This\Memory   = *Value\Memory
    *This\Scope    = *Value\Scope|#Value_Reference
    *This\Variable = *Value\Variable
    ProcedureReturn *Value
  EndIf
EndProcedure
Procedure.i Std_Reference__Form()
  ProcedureReturn PushSValue("<NULL>")
EndProcedure

DataSection
  ReferenceClass:
    Data.c #Object_Function : Data.s _CM(new) ;{
      Data.i @Std_Reference__New()
    ;}
    Data.c #Object_Function : Data.s _CM(def) ;{
      Data.i @Std_Reference__DefAndSet()
    Data.s _CM(set)
    ;}
    Data.c #Object_Function : Data.s _CM(form) ;{
      Data.i @Std_Reference__Form()
    ;}
    Data.c #False  
EndDataSection
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = --
; EnableXP