;**************************************************************
;     Variant (class)
;
; Autor: Josef Sniatecki
; Creation date: 08.04.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i Std_Variant__New()
  *Current\This\Scope|#Value_Binary
EndProcedure
Procedure.i Std_Variant__DefAndSet()
  Protected *This.Value = *Current\This, *Value.Value
  
  If PopValueAddress(@*Value)
    If *This\Scope&#Value_Reference
      _Move(*This, Original)
    EndIf
    *This\Class = *Value\Class
    *This\Scope = *Value\Scope&~(#Value_Reference|#Value_Literal)
    Select *Value\Class
      Case *IntegerClass, *BooleanClass
        *This\Integer   = AllocateMemory(_Sz(Integer))
        *This\Integer\I = *Value\Integer\I
      Case *FloatClass
        *This\Float   = AllocateMemory(_Sz(Float))
        *This\Float\F = *Value\Float\F
      Case *QuadClass
        *This\Quad   = AllocateMemory(_Sz(Quad))
        *This\Quad\Q = *Value\Quad\Q
      Case *DoubleClass
        *This\Double   = AllocateMemory(_Sz(Double))
        *This\Double\D = *Value\Double\D
      Case *StringClass
        *This\String   = AllocateMemory(_Sz(String))
        *This\String\S = *Value\String\S
      Case *PointerClass
        *This\Object = *Value\Object
      Case *VariantClass
        ;Do nothing
      Default
        CallClassMethod(*Value\Class, #ClassMethod_New, -1, *This, #False)
        OperateValue(#Operator_Set, *This, *Value)
    EndSelect
    UpdateReferences(*This)
    ProcedureReturn *Value
  EndIf
EndProcedure
Procedure.i Std_Variant__Form()
  ProcedureReturn PushSValue("<VARIANT>")
EndProcedure



DataSection
  VariantClass:
    Data.c #Object_Function : Data.s _CM(new) ;{
      Data.i @Std_Variant__New()
    ;}
    Data.c #Object_Function : Data.s _CM(def) ;{
      Data.i @Std_Variant__DefAndSet()
    Data.s _CM(set)
    ;}
    Data.c #Object_Function : Data.s _CM(form) ;{
      Data.i @Std_Variant__Form()
    ;}
    Data.c #False
EndDataSection
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 66
; FirstLine = 47
; Folding = --
; EnableXP