;**************************************************************
;     GUI
;
; Autor: Josef Sniatecki
; Creation date: 06.07.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i OpenGUIWindow()
  GUI = #True
  
  OpenWindow(#GUIWindow, #PB_Ignore, #PB_Ignore, GUI_Width, GUI_Height, "Operno", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget)
    CreateMenu(#GUIMenu, WindowID(#GUIWindow))
      MenuTitle("Operno")
        MenuItem(#GUIMenu_Operno_NewInstance , "New instance" + #T + "Ctrl+N")
        MenuItem(#GUIMenu_Operno_Restart , "Restart" + #T + "Ctrl+R")
        MenuItem(#GUIMenu_Operno_OpenConsole, "Open console")
        MenuBar()
        MenuItem(#GUIMenu_Operno_SaveRecord, "Save record")
        MenuItem(#GUIMenu_Operno_SelectFont, "Select font...")
        MenuBar()
        MenuItem(#GUIMenu_Operno_Close, "Close")
      MenuTitle("Execute")
        MenuItem(#GUIMenu_Execute_Input          , "Input" + #T + "F5")
        MenuItem(#GUIMenu_Execute_InputPlusResult, "Input + Result" + #T + "F6")
        MenuBar()
        MenuItem(#GUIMenu_Execute_File, "File")
        MenuItem(#GUIMenu_Execute_ClipboardContents, "Clipboard contents")
        MenuBar()
        MenuItem(#GUIMenu_Execute_TokenCompiler, "Token compiler")
      MenuTitle("Output")
        MenuItem(#GUIMenu_Output_Copy , "Copy")
        MenuItem(#GUIMenu_Output_Clear, "Clear" + #T + "Strg + C")
        MenuBar()
        MenuItem(#GUIMenu_Output_DisplayInput, "Display input")
      MenuTitle("HTML")
        MenuItem(#GUIMenu_HTML_GenerateHilightedFile, "Generate hilighted file")
        MenuItem(#GUIMenu_HTML_Configuration        , "Configuration")
      MenuTitle("Tools")
        MenuItem(#GUIMenu_Tools_Editor, "Editor" + #T + "F2")
        MenuItem(#GUIMenu_Tools_Viewer, "Viewer" + #T + "F3")
      MenuTitle("Extras")
        MenuItem(#GUIMenu_Extras_About   , "About")
        MenuItem(#GUIMenu_Extras_Help    , "Help" + #T + "F1")
        MenuItem(#GUIMenu_Extras_Tutorial, "Tutorial")
        MenuBar()
        MenuItem(#GUIMenu_Extras_Screenshot, "Screenshot" + #T + "F11")
    
    EditorGadget(#GUI_Output, 20, 20, GUI_Width - 40  , GUI_Height - 220, #PB_Editor_ReadOnly)
    EditorGadget(#GUI_Input, 20, GUI_Height - 170, GUI_Width - 40, 130)
    Frame3DGadget(#GUI_OutputFrame, 10, 0, GUI_Width - 20, GUI_Height - 190, "Output")
    Frame3DGadget(#GUI_InputFrame, 10, GUI_Height - 190, GUI_Width - 20, 160, "Input (F5 or F6)")
    
    SetMenuItemState(#GUIMenu, #GUIMenu_Output_DisplayInput, GUI_DisplayInput)
    
    LoadFont(#GUIFont, GUI_Font, GUI_FontSize)
    SetGadgetFont(#GUI_Output, FontID(#GUIFont))
    SetGadgetColor(#GUI_Output, #PB_Gadget_FrontColor, GUI_FrontColor)
    SetGadgetColor(#GUI_Output, #PB_Gadget_BackColor, GUI_BackColor)
    SetGadgetFont(#GUI_Input, FontID(#GUIFont))
    SetGadgetColor(#GUI_Input, #PB_Gadget_FrontColor, GUI_FrontColor)
    SetGadgetColor(#GUI_Input, #PB_Gadget_BackColor, GUI_BackColor)
    
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_N, #GUIMenu_Operno_NewInstance)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_R, #GUIMenu_Operno_Restart)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F5                    , #GUIMenu_Execute_Input)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F6                    , #GUIMenu_Execute_InputPlusResult)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_C, #GUIMenu_Output_Clear)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F2                    , #GUIMenu_Tools_Viewer)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F1                    , #GUIMenu_Extras_Help)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F11                   , #GUIMenu_Extras_ScreenShot)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F2                    , #GUIMenu_Tools_Editor)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_F3                    , #GUIMenu_Tools_Viewer)
    
    CreatePopupMenu(#GUIMenuI)
      MenuItem(#GUIMenuI_Cut  , "Cut" + #T + "Ctrl+X")
      MenuItem(#GUIMenuI_Copy , "Copy" + #T + "Ctrl+C")
      MenuItem(#GUIMenuI_Paste, "Paste" + #T + "Ctrl+V")
      MenuBar()
      MenuItem(#GUIMenuI_SelectAll     , "Select all" + #T + "Ctrl+A")
      MenuItem(#GUIMenuI_ContinueInFile, "Continue in file")
    
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_X, #GUIMenuI_Cut)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_C, #GUIMenuI_Copy)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_V, #GUIMenuI_Paste)
    AddKeyboardShortcut(#GUIWindow, #PB_Shortcut_Control|#PB_Shortcut_A, #GUIMenuI_SelectAll)
EndProcedure
Procedure.i OpenGUI()
  Protected Event.i, Window.i, Menu.i, Gadget.i, Type.i
  Protected String.s, *Result.Value, File.i
  Protected WindowWidth.i, WindowHeight.i, Selection.CHARRANGE
  
  ; Open the graphical user interface:
  If GUI
    ; If the GUI is already opened, display only a message:
    OutputFL(#Symbol_Message, "Active user input is set to enabled.")
  Else
    ; Open the window and all it's gadgets:
    OpenGUIWindow()
    Interface_Head()
  EndIf
  Interface_Startup()
  
  ; Set the cursor on the input:
  SetActiveGadget(#GUI_Input)
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Menu   = EventMenu()
    Gadget = EventGadget()
    Type   = EventType()
    
    Select Window
      Case #GUIWindow
        Select Event
          Case #PB_Event_Menu
            Select Menu
              Case #GUIMenu_Operno_NewInstance
                ; Call a new operno instance:
                RunProgram("Operno.exe", "nopreview", "")
              Case #GUIMenu_Operno_Restart
                RunProgram("Operno.exe", "nopreview", "")
                Break
              Case #GUIMenu_Operno_OpenConsole
                ; Open the old console:
                HideWindow(#GUIWindow, #True)
                GUI = #False
                
                OpenUI()
                
                GUI = #True
                HideWindow(#GUIWindow, #False)
                Truncation = 0
                OutputFL(#Symbol_Message, "GUI restarted")
              Case #GUIMenu_Operno_SaveRecord
                ; Save all typed codes:
                SaveRecord()
              Case #GUIMenu_Operno_SelectFont
                If FontRequester(GUI_Font, GUI_FontSize, 0)
                  GUI_Font     = SelectedFontName()
                  GUI_FontSize = SelectedFontSize()
                  
                  LoadFont(#GUIFont, GUI_Font, GUI_FontSize)
                  SetGadgetFont(#GUI_Output, FontID(#GUIFont))
                  SetGadgetFont(#GUI_Input, FontID(#GUIFont))
                EndIf
              Case #GUIMenu_Operno_Close
                ; Close the GUI:
                Break
                
              Case #GUIMenu_Execute_Input
                ; Execute the typed code:
                String = GetGadgetText(#GUI_Input)
                SetGadgetText(#GUI_Input, "")
                If GUI_DisplayInput
                  GUI_Coloring = #False
                  OutputFL(#Symbol_Input, String)
                  GUI_Coloring = #True
                EndIf
                ExecuteCommands(String, 0, #True)
                If Truncation = #Truncation_End
                  Break
                Else
                  Truncation = 0
                EndIf
                If Not OutputE()
                  AddRecord(String)
                EndIf
                
                ClearLevels()
                ClearStack()
                
                UpdateViewer()
              Case #GUIMenu_Execute_InputPlusResult
                ; Evaluate the given code and display its
                ; result on the output:
                String = GetGadgetText(#GUI_Input)
                SetGadgetText(#GUI_Input, "")
                If GUI_DisplayInput
                  GUI_Coloring = #False
                  OutputFL(#Symbol_Input, String)
                  GUI_Coloring = #True
                EndIf
                *Result = ExecuteCommands(String, 0, #True)
                If Truncation = #Truncation_End
                  Break
                Else
                  Truncation = 0
                EndIf
                If Not OutputE()
                  OutputFL(#Symbol_Output, FormatValue(*Result))
                  AddRecord("out " + String)
                EndIf
                
                ClearLevels()
                ClearStack()
                
                UpdateViewer()
                
              Case #GUIMenu_Execute_File
                Interface_Execute()
              Case #GUIMenu_Execute_ClipboardContents
                Interface_ExecuteClipboard()
              Case #GUIMenu_Execute_TokenCompiler
                Interface_Compile()
                
              Case #GUIMenu_Output_Copy
                SetClipboardText(GetGadgetText(#GUI_Output))
              Case #GUIMenu_Output_Clear
                SetGadgetText(#GUI_Output, "")
              Case #GUIMenu_Output_DisplayInput
                ; Enable/Disable the displaying of the typed input:
                GUI_DisplayInput = 1 - GUI_DisplayInput
                SetMenuItemState(#GUIMenu, #GUIMenu_Output_DisplayInput, GUI_DisplayInput)
                
              Case #GUIMenu_HTML_GenerateHilightedFile
                Interface_HTML()
              Case #GUIMenu_HTML_Configuration
                HTMLGeneratorConfiguration()
                
              Case #GUIMenu_Tools_Editor
                RunProgram("Editor.exe")
              Case #GUIMenu_Tools_Viewer
                OpenViewer()
              Case #GUIMenu_Extras_About
                Interface_About()
              Case #GUIMenu_Extras_Help
                ; Open the HTML-documentation:
                Interface_OpenHelp()
              Case #GUIMenu_Extras_Tutorial
                RunProgram("Operno.exe", #Q + #OpernoPath + "Tutorials\" + LCase(User_Language) + "\action.op_c" + #Q, #OpernoPath)
              Case #GUIMenu_Extras_Screenshot
                Delay(500)
                SaveWindowScreenshot(#GUIWindow, "Screenshot-" + Str(Date()) + ".bmp")
                
              
              Case #GUIMenuI_Cut
                EditorGadgetCut(#GUI_Input)
              Case #GUIMenuI_Copy
                EditorGadgetCopy(#GUI_Input)
              Case #GUIMenuI_Paste
                EditorGadgetPaste(#GUI_Input)
              Case #GUIMenuI_SelectAll
                EditorGadgetSelectAll(#GUI_Input)
              Case #GUIMenuI_ContinueInFile
                File = CreateFile(#PB_Any, "Data\Temp.op_c")
                  If Record
                    WriteStringN(File, Record)
                  EndIf
                  String = GetGadgetText(#GUI_Input)
                  If String
                    WriteStringN(File, String)
                  EndIf
                CloseFile(File)
                RunProgram("Editor.exe", #Q + #OpernoPath + "Data\Temp.op_c" + #Q, "")
            EndSelect
          Case #PB_Event_MaximizeWindow, #PB_Event_SizeWindow
            ; Resize all gadgets with the window:
            WindowWidth  = WindowWidth(#GUIWindow)
            WindowHeight = WindowHeight(#GUIWindow)
            ResizeGadget(#GUI_Output, 20, 20, WindowWidth - 40  , WindowHeight - 220)
            ResizeGadget(#GUI_Input, 20, WindowHeight - 170, WindowWidth - 40, 130)
            ResizeGadget(#GUI_OutputFrame, 10, 0, WindowWidth - 20, WindowHeight - 190)
            ResizeGadget(#GUI_InputFrame, 10, WindowHeight - 190, WindowWidth - 20, 160)
          Case #WM_RBUTTONDOWN
            If CursorOverGadget(#GUIWindow, #GUI_Input)
              DisplayPopupMenu(#GUIMenuI, WindowID(#GUIWindow))
            EndIf
          Case #PB_Event_CloseWindow
            Break
        EndSelect
      Case #ViewerWindow
        ; Check viewer events:
        ExamineViewer(Event, Menu, Gadget, Type)
    EndSelect
  ForEver
  
  GUI_Width  = WindowWidth(#GUIWindow)
  GUI_Height = WindowHeight(#GUIWindow)
  
  CloseWindow(#GUIWindow)
  FreeFont(#GUIFont)
  GUI = #False
EndProcedure
Procedure.i DisplayGUIOutput(Text.s)
  Protected *Char.Character, Attribute.s, Char.s
  Protected *Start.Character, ID.i = GadgetID(#GUI_Output)
  
  SendMessage_(ID, #EM_SETSEL, -1, -1)
  
  If GUI_Coloring
    *Char = @Text
    While *Char\c
      Select *Char\c
        Case '$'
          *Char + 1
          *Start = *Char
          Repeat
            Select *Char\c
              Case '$'
                Break
              Case 0
                Break 2
            EndSelect
            *Char + 1
          ForEver
          
          Attribute = LCase(PeekS(*Start, *Char - *Start))
          Select Attribute
            Case "nc"
              EditorGadgetSetColor(#GUI_Output, GUI_FrontColor)
            Case "ns"
              EditorGadgetSetStyle(#GUI_Output, #Null)
            Case "n"
              EditorGadgetSetColor(#GUI_Output, GUI_FrontColor)
              EditorGadgetSetStyle(#GUI_Output, #Null)
            Case "b"
              EditorGadgetSetStyle(#GUI_Output, #PB_EditorGadget_Bold)
            Case "i"
              EditorGadgetSetStyle(#GUI_Output, #PB_EditorGadget_Italic)
            Case "u"
              EditorGadgetSetStyle(#GUI_Output, #PB_EditorGadget_Underline)
            Case "red"
              EditorGadgetSetColor(#GUI_Output, #Red)
            Case "green"
              EditorGadgetSetColor(#GUI_Output, #Green)
            Case "blue"
              EditorGadgetSetColor(#GUI_Output, #Blue)
            Case "yellow"
              EditorGadgetSetColor(#GUI_Output, #Yellow)
            Case "magenta"
              EditorGadgetSetColor(#GUI_Output, #Magenta)
            Case "cyan"
              EditorGadgetSetColor(#GUI_Output, #Cyan)
            Case "white"
              EditorGadgetSetColor(#GUI_Output, #White)
            Case "gray"
              EditorGadgetSetColor(#GUI_Output, #Gray)
            Case ""
              SendMessage_(ID, #EM_REPLACESEL, 1, @"$")
          EndSelect
        Case 13
          *Char + 1
          Char = Chr(10)
          SendMessage_(ID, #EM_REPLACESEL, 1, @Char)
          
          EditorGadgetSetColor(#GUI_Output, GUI_FrontColor)
          EditorGadgetSetStyle(#GUI_Output, #Null)
        Default
          Char = Chr(*Char\c)
          SendMessage_(ID, #EM_REPLACESEL, 1, @Char)
      EndSelect
      *Char + 1
    Wend
    
    EditorGadgetSetColor(#GUI_Output, GUI_FrontColor)
    EditorGadgetSetStyle(#GUI_Output, #Null)
  Else
    SendMessage_(ID, #EM_REPLACESEL, 1, @Text)
  EndIf
  
  WindowEvent()
EndProcedure
Procedure.s ReadGUIInput()
  Protected Event.i, Window.i, Menu.i, Gadget.i
  Protected WindowWidth.i, WindowHeight.i
  Protected String.s
  
  ; Set the cursor on the input:
  SetActiveGadget(#GUI_Input)
  
  Repeat
    Event  = WaitWindowEvent()
    Window = EventWindow()
    Menu   = EventMenu()
    Gadget = EventGadget()
    
    Select Window
      Case #GUIWindow
        Select Event
          Case #PB_Event_Menu
            Select Menu
              Case #GUIMenu_Execute_Input, #GUIMenu_Execute_InputPlusResult
                String = GetGadgetText(#GUI_Input)
                SetGadgetText(#GUI_Input, "")
                OutputT(String) : OutputN()
                ProcedureReturn String
              Case #GUIMenu_Extras_Help
                ; Open the HTML-documentation:
                RunProgram(GetCurrentDirectory() + "Help\" + LCase(User_Language) + "\Index.html")
            EndSelect
          Case #PB_Event_MaximizeWindow, #PB_Event_SizeWindow
            WindowWidth  = WindowWidth(#GUIWindow)
            WindowHeight = WindowHeight(#GUIWindow)
            ResizeGadget(#GUI_Output, 20, 20, WindowWidth - 40  , WindowHeight - 220)
            ResizeGadget(#GUI_Input, 20, WindowHeight - 170, WindowWidth - 40, 130)
            ResizeGadget(#GUI_OutputFrame, 10, 0, WindowWidth - 20, WindowHeight - 190)
            ResizeGadget(#GUI_InputFrame, 10, WindowHeight - 190, WindowWidth - 20, 160)
          Case #PB_Event_CloseWindow
            Break
        EndSelect
    EndSelect
  ForEver
  
  Truncation = #Truncation_End
EndProcedure

; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 414
; FirstLine = 307
; Folding = +
; EnableXP
; CompileSourceDirectory