;**************************************************************
;     Tutorial
;
; Autor: Josef Sniatecki
; Creation date: 30.05.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i StartTutorial(FileName.s)
  Protected File.i, String.s
  Protected Code.s
  
  File = ReadFile(#PB_Any, FileName)
  If File
    While Not Eof(File)
      String = ReadString(File)
      Select String
        Case "#TITLE"
          OutputHL()
          OutputFL(#Symbol_Default, "< " + ReadString(File) + " >", 0)
        Case "#CODE"
          While Not Eof(File)
            String = ReadString(File)
            Select String
              Case "#END CODE"
                Break
              Default
                OutputFL(#Symbol_None, String, 2)
                WaitForReturn()
            EndSelect
          Wend
        Case "#EXECUTE"
          While Not Eof(File)
            String = ReadString(File)
            Select String
              Case "#END EXECUTE"
                ExecuteCommands(Code) : _EB(2)
                Break
              Default
                If Code
                  Code + #N
                EndIf
                Code + String
            EndSelect
          Wend
        Case "#STOP"
          WaitForReturn()
        Case "#SPACE"
          OutputFL(#Symbol_None, "", 1)
        Case ""
          ; Ignore spaces
        Default
          OutputFL(#Symbol_None, String, 1)
      EndSelect
    Wend
    OutputHL()
    CloseFile(File)
  Else
    _Error("Can not open the tutorial: " + #Q + FileName + #Q)
  EndIf
EndProcedure

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableXP