;**************************************************************
;     Viewer
;
; Autor: Josef Sniatecki
; Creation date: 05.10.2009
;**************************************************************
;   (c) 2009 Josef Sniatecki
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; As published by the Free Software Foundation; either version
; 3 of the License, Or (at your option) any later version.
;
; This program is distributed in the hope that it will be
; useful, but WITHOUT ANY WARRANTY; without even the implied
; warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR
; PURPOSE. See the GNU General Public License For more details.
;
; You should have received a copy of the GNU General Public
; License along With this program;
; If Not, see "http://www.gnu.org/licenses/".
;**************************************************************



Procedure.i OpenViewer()
  OpenWindow(#ViewerWindow, #PB_Ignore, #PB_Ignore, 300, 450, "Viewer", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_TitleBar|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget, WindowID(#GUIWindow))
    TreeGadget(#Viewer_Tree, 0, 0, 300, 450)
    
    SetGadgetFont(#Viewer_Tree, FontID(#GUIFont))
  
  UpdateViewer()
EndProcedure
Procedure.i ExamineViewer(Event.i, Menu.i, Gadget.i, Type.i)
  Protected *Object.Object, *Value.Value
  
  Select Event
    Case #PB_Event_CloseWindow
      CloseWindow(#ViewerWindow)
    Case #PB_Event_MaximizeWindow, #PB_Event_SizeWindow
      ResizeGadget(#Viewer_Tree, 0, 0, WindowWidth(#ViewerWindow), WindowHeight(#ViewerWindow))
  EndSelect
EndProcedure
Procedure.i UpdateViewer()
  If IsWindow(#ViewerWindow)
    ClearGadgetItems(#Viewer_Tree)
    UpdateViewerTree(Main\Object)
    UpdateViewerTree(*PreprocessorObject)
    UpdateViewerTree(*StandardLibrary)
    UpdateViewerTree(*StandardClassLibrary)
  EndIf
EndProcedure
Procedure.i UpdateViewerTree(*Object.Object, Level.i = 0)
  Protected Text.s, *Item.QueueItem
  
  If Not *Object\Reference
    Select *Object\Type
      Case #Object_Variable
        If *Object\Variable\Value\Class\Group\ClassMethod[#ClassMethod_Format]
          Text = *Object\Name + "." + ClassName(*Object\Variable\Value\Class) + " = " + FormatValue(*Object\Variable\Value)
        Else
          Text = *Object\Name + "." + ClassName(*Object\Variable\Value\Class)
        EndIf
      Case #Object_Function
        Text = *Object\Name + "()"
      Case #Object_Group
        Text = *Object\Name
    EndSelect
  Else
    Text = *Object\Name + " -> " + ObjectPath(*Object\Reference)
  EndIf
  
  AddGadgetItem(#Viewer_Tree, -1, Text, 0, Level)
  SetGadgetItemData(#Viewer_Tree, CountGadgetItems(#Viewer_Tree) - 1, *Object)
  
  If Not *Object\Reference
    Select *Object\Type
      Case #Object_Variable
        If *Object\Variable\Value\Scope&#Value_Searchable And Not *Object\Variable\Value\Scope&#Value_Reference
          *Item = *Object\Variable\Value\Object\Group\ObjectQueue\First
          While *Item
            UpdateViewerTree(*Item\Object, Level + 1)
            _Move(*Item, N)
          Wend
        EndIf
      Case #Object_Group
        *Item = *Object\Group\ObjectQueue\First
        While *Item
          UpdateViewerTree(*Item\Object, Level + 1)
          _Move(*Item, N)
        Wend
    EndSelect
  EndIf
EndProcedure
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 20
; Folding = -
; EnableXP